package com.jclark.xsl;

class AppendExpression implements Expression {
  private Expression expr1;
  private Expression expr2;

  AppendExpression(Expression expr1, Expression expr2) {
    this.expr1 = expr1;
    this.expr2 = expr2;
  }

  public String eval(ProcessContext context, Node sourceNode) throws XSLException {
    return expr1.eval(context, sourceNode) + expr2.eval(context, sourceNode);
  }

  public void evalAdd(ProcessContext context, Node sourceNode, Result result) throws XSLException {
    expr1.evalAdd(context, sourceNode, result);
    expr2.evalAdd(context, sourceNode, result);
  }
}
