package com.jclark.xsl;

import java.util.Enumeration;

class AttributeRuleSet extends RuleSet {
  private static
  class AttributeRule extends Rule {
    final AttributeListTemplate attributes;
    AttributeRule(Matcher matcher, int priority, AttributeListTemplate attributes) {
      super(matcher, priority);
      this.attributes = attributes;
    }
  }

  void add(Enumeration patterns, int priority, AttributeListTemplate attributes) {
    while (patterns.hasMoreElements())
      add((Matcher)patterns.nextElement(), priority, attributes);
  }

  void add(Matcher pattern, int priority, AttributeListTemplate attributes) {
      super.add(new AttributeRule(pattern, priority, attributes));
  }


  AttributeListTemplate getAttributes(ProcessContext context, Node node) throws XSLException {
    // FIXME should catch duplicates here
    AttributeListTemplate atts = null;
    ComposeAttributeListTemplate composeAtts = null;
    for (Enumeration enum = potentialRules(node); enum.hasMoreElements();) {
      AttributeRule rule = (AttributeRule)enum.nextElement();
      if (rule.matcher.matches(context, node)) {
	if (atts == null)
	  atts = rule.attributes;
	else if (composeAtts == null)
	  atts = composeAtts
	    = new ComposeAttributeListTemplate(atts, rule.attributes);
	else
	  composeAtts.add(rule.attributes);
      }
    }
    return atts;
  }
}
