package com.jclark.xsl;

import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;

class ComposeAttributeListTemplate implements AttributeListTemplate {
  static private
  class Attribute {
    Attribute(AttributeList atts, int index) {
      this.atts = atts;
      this.index = index;
    }
    AttributeList atts;
    int index;
  }

  static private
  class AttributeListImpl implements AttributeList {
    private Vector v = new Vector();
    private Hashtable map = new Hashtable();
    AttributeListImpl(Enumeration templates, ProcessContext context, Node sourceNode) throws XSLException {
      while (templates.hasMoreElements()) {
	AttributeList atts = ((AttributeListTemplate)templates.nextElement()).instantiate(context, sourceNode);
	int len = atts.getAttributeCount();
	for (int i = 0; i < len; i++) {
	  Name name = atts.getAttributeName(i);
	  if (map.get(name) == null) {
	    map.put(name, new Integer(v.size()));
	    Attribute att = new Attribute(atts, i);
	    v.addElement(att);
	  }
	}

      }
    }
    public
    int getAttributeCount() {
      return v.size();
    }
  
    public
    String getAttributeValue(Name name) {
      Integer i = (Integer)map.get(name);
      if (i == null)
	return null;
      Attribute att = (Attribute)v.elementAt(i.intValue());
      return att.atts.getAttributeValue(att.index);
    }

    public
    int getAttributeIndex(Name name) {
      Integer i = (Integer)map.get(name);
      if (i == null)
	return -1;
      return i.intValue();
    }

    public
    Name getAttributeName(int i) {
      Attribute att = (Attribute)v.elementAt(i);
      return att.atts.getAttributeName(att.index);
    }
  
    public
    String getAttributeValue(int i) {
      Attribute att = (Attribute)v.elementAt(i);
      return att.atts.getAttributeValue(att.index);
    }

  }

  private Vector templates = new Vector();

  ComposeAttributeListTemplate(AttributeListTemplate atts1, AttributeListTemplate atts2) {
    add(atts1);
    add(atts2);
  }

  void add(AttributeListTemplate atts) {
    templates.addElement(atts);
  }

  public
  AttributeList instantiate(ProcessContext context, Node sourceNode) throws XSLException {
    return new AttributeListImpl(templates.elements(), context, sourceNode);
  }
  
}
