package com.jclark.xsl;

import java.net.URL;

public interface Node extends AttributeList {
  static byte ELEMENT = 0;
  static byte TEXT = 1;
  static byte ROOT = 2;
  static byte ATTRIBUTE = 3;
  static int N_TYPES = 4;
  byte getType();
  /**
   * Returns element type name for element.
   */
  Name getName();
  String getData();
  Node getParent();
  Node getAttribute(Name name);
  /**
   * If strip is true, ignore text nodes that contain whitespace
   * only, unless xml:space="preserve" is true.
   */
  NodeIterator getChildren(boolean strip);
  NodeIterator getFollowingSiblings(boolean strip);
  URL getURL();
  int getLineNumber();
  NamespacePrefixMap getNamespacePrefixMap();
  int compareTo(Node node);
}
