package com.jclark.xsl;

class QueryExpression implements Expression {
  private Query query;

  QueryExpression(Query query) {
    this.query = query;
  }

  public
  String eval(ProcessContext context, Node sourceNode) throws XSLException {
    Node node = query.select(context, sourceNode).next();
    if (node == null)
      return "";
    StringBuffer buf = new StringBuffer();
    addContent(context, node, buf);
    return buf.toString();
  }

  public
  void evalAdd(ProcessContext context, Node sourceNode, Result result) throws XSLException {
    Node node = query.select(context, sourceNode).next();
    if (node != null)
      addContent(context, node, result);
  }

  private static
  void addContent(ProcessContext context, Node node, Result result) throws XSLException {
    String data = node.getData();
    if (data != null)
      result.characters(data);
    else {
      for (NodeIterator iter = node.getChildren(context.getStripSource(node));;) {
	node = iter.next();
	if (node == null)
	  break;
	addContent(context, node, result);
      }
    }
  }

  private static
  void addContent(ProcessContext context, Node node, StringBuffer result) {
    String data = node.getData();
    if (data != null)
      result.append(data);
    else {
      for (NodeIterator iter = node.getChildren(context.getStripSource(node));;) {
	node = iter.next();
	if (node == null)
	  break;
	addContent(context, node, result);
      }
    }
  }
}
